/* This file is part of the KDE project
   Copyright (c) 2004 Kevin Ottens <ervin ipsquad net>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef MEDIUMBUTTON_H
#define MEDIUMBUTTON_H

#include <qbutton.h>
#include <qpoint.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qcursor.h>
#include <qtimer.h>
#include <kfileitem.h>
#include <kpanelapplet.h>

class MediumButton : public QButton
{
Q_OBJECT

public:
	MediumButton(QWidget *parent, const KFileItem &fileItem);
	~MediumButton();
	const KFileItem &fileItem() const;
	void setFileItem(const KFileItem &fileItem);
	void setPanelPosition(KPanelApplet::Position position);

protected:
	void paintEvent(QPaintEvent *);
	void refreshIcon();
	void drawButton(QPainter *p);
	void drawButtonLabel(QPainter *p);
	void enterEvent(QEvent *e);
	void leaveEvent(QEvent *e);
	void resizeEvent(QResizeEvent *e);
	void mousePressEvent(QMouseEvent *e);
	void dragEnterEvent( QDragEnterEvent* );
	void dragLeaveEvent( QDragLeaveEvent* );
	void dropEvent(QDropEvent *e);

protected slots:
	void slotSettingsChanged(int);
	void slotIconChanged(int);
	void slotDragOpen();

private:
	KFileItem mFileItem;

	QTimer mOpenTimer;

	QPixmap mIcon;
	QPixmap mIconHighlight;

	KPanelApplet::Position mPanelPosition;
	bool mHighlight;
	bool mChangeCursorOverItem;
};

#endif
