/* This file is part of the KDE project
   Copyright (c) 2004 Kevin Ottens <ervin ipsquad net>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef MEDIUMPOPUPMENU_H
#define MEDIUMPOPUPMENU_H

#include <qwidget.h>
#include <kpopupmenu.h>
#include <kfileitem.h>
#include <kmimetype.h> // for KDEDesktopMimeType

/**
  *@author ervin
  */

class MediumPopupMenu : public KPopupMenu
{
   Q_OBJECT

public:
	MediumPopupMenu(const KFileItem &fileItem, QWidget *parent=0);
	~MediumPopupMenu();

protected:
	inline void queryMediaManager();
	inline void loadServices();

protected slots:
	void slotRunService(int id);

private:
	KFileItem mFileItem;
	KURL mBaseURL;

	KPopupMenu mServicesSubMenu;

	QMap<int, KDEDesktopMimeType::Service> mServicesMap;
	QValueList<KDEDesktopMimeType::Service> mMediumServices;
	QValueList<KDEDesktopMimeType::Service> mDirectoryServices;
};

#endif
